/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>

/***************************************************************************************/
void get_import_filename()
{
	char *tstringpointer, tstring[250];
	int tint;
	extern GtkWidget *openfile, *import_options_entry;
	extern char *error_message, nothing_entered[], invalid_entry[];
	extern display_message(), exit_openfile();
	
	
	tstringpointer = gtk_file_selection_get_filename(GTK_FILE_SELECTION(openfile));
	sscanf(tstringpointer, "%s", tstring);
   	if (strlen(tstring) == 0)
   	{
   		error_message = nothing_entered;
		display_message();
		return;
	}
	tint = strlen(tstring);
	if ((tstring[tint - 1] == '/') || (tstring[tint - 1] == '.'))
	{
		error_message = invalid_entry;
		display_message();
		return;
	}
	strcpy(tstring, tstringpointer);
	gtk_entry_set_text(GTK_ENTRY(import_options_entry), tstring);
	exit_openfile();
}
/******************************************************************************************/
void ok_import()
{
	int tint, tint2, count = 0, error_flag = 0, format = 0, seperator = 0, reload_flag = 0;
   	int highlist = 0, lowlist = 0, middlelist = 0, found_flag = 0, dateformat = 0, tint3;
   	FILE *infile, *errorlog_file, *outfile, *outfile2;
   	char tstring[250], tstring2[250], error_msg[50], *tstringpointer;
   	char tname[NAME_SIZE], tsymbol[SYMBOL_SIZE], tstring3[25];
   	unsigned long importline = 0, tlong = 0, tlong2 = 0, tlong3 = 0, linecount = 0;
   	unsigned long date = 0, volume = 0, openint = 0;
   	long records = 0;
   	float tfloat=0.0,tfloat2=0.0,tfloat3=0.0,tfloat4=0.0,open=0.0,high=0.0,low=0.0,close=0.0;
   	extern char *errorlog, *lastdir, *datapath, *error_message, *importfile;
   	extern char nothing_entered[], invalid_entry[], cant_open_errorlog[];
   	extern char cant_open_importfile[], cant_create_tempfile[], cant_create_chart[];
   	extern char error_notify[], symbol[SYMBOL_SIZE];
	GtkWidget *hbox, *frame, *statusbar;
	extern int chartflag;
	extern GtkWidget *import_options_radio, *import_options_radio2, *progwindow;
	extern GtkWidget *import_options_radio3, *import_options_radio4, *import_options_radio5;
	extern GtkWidget *import_options_radio6, *import_options_radio7, *import_options_entry;
	extern GtkWidget *import_options_radio8, *import_options_radio9, *import_options_radio10;
	extern exit_import_options_window(), exit_progwindow(), display_message();
	extern load_file(), draw();
	
	
	
	if (GTK_TOGGLE_BUTTON (import_options_radio)->active)
		format = 1;
	if (GTK_TOGGLE_BUTTON (import_options_radio2)->active)
		format = 2;
	if (GTK_TOGGLE_BUTTON (import_options_radio3)->active)
		format = 3;
	if (GTK_TOGGLE_BUTTON (import_options_radio4)->active)
		format = 4;
	if (GTK_TOGGLE_BUTTON (import_options_radio5)->active)
		format = 5;
	if (GTK_TOGGLE_BUTTON (import_options_radio6)->active)
		seperator = 1;
	if (GTK_TOGGLE_BUTTON (import_options_radio7)->active)
		seperator = 2;
	if (GTK_TOGGLE_BUTTON (import_options_radio8)->active)
		dateformat = 1;
	if (GTK_TOGGLE_BUTTON (import_options_radio9)->active)
		dateformat = 2;
	if (GTK_TOGGLE_BUTTON (import_options_radio10)->active)
		dateformat = 3;
	tstringpointer = gtk_entry_get_text(GTK_ENTRY(import_options_entry));
	sscanf(tstringpointer, "%s", tstring);
   	if (strlen(tstring) == 0)
   	{
   		error_message = nothing_entered;
		display_message();
		return;
	}
	tint = strlen(tstring);
	if ((tstring[tint - 1] == '/') || (tstring[tint - 1] == '.'))
	{
		error_message = invalid_entry;
		display_message();
		return;
	}
	if (importfile != NULL)
   		free(importfile);
   	importfile = (char *)malloc(sizeof(tstring) + 1);
	strcpy(importfile, tstring);
		
      	infile = fopen(importfile, "r");
      	if (! infile)
      	{
      		error_message = cant_open_importfile;
		display_message();
		return;
      	}
     	if (lastdir != 0)
     		free(lastdir);
     	strcpy(tstring, importfile);
     	tstringpointer = strrchr(importfile, '/');
     	*(tstringpointer + 1) = '*';
     	*(tstringpointer + 2) = 0;
     	lastdir = (char *) malloc(strlen(tstring) + 1);
     	strcpy(lastdir, tstring);
     	
     	linecount = 0;
	while (fgets(tstring, 250, infile) != NULL)
		linecount++;
	rewind(infile);
	importline = 1;
	errorlog_file = fopen(errorlog, "w");
	if (! errorlog_file)
	{
		error_message = cant_open_errorlog;
		display_message();
		return;
	}
	
	progwindow = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (progwindow), "delete_event",
			    GTK_SIGNAL_FUNC (exit_progwindow), NULL);
	gtk_signal_connect (GTK_OBJECT (progwindow), "destroy",
			    GTK_SIGNAL_FUNC (exit_progwindow), NULL);
	gtk_window_position(GTK_WINDOW (progwindow), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (progwindow), " ");
	gtk_container_border_width (GTK_CONTAINER (progwindow), 0);
	
	frame = gtk_frame_new ("Importing:");
      	gtk_container_border_width (GTK_CONTAINER (frame), 10);
      	gtk_container_add (GTK_CONTAINER (progwindow), frame);
      	gtk_widget_show (frame);
      	
      	hbox = gtk_hbox_new (FALSE, 0);
      	gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_container_add (GTK_CONTAINER (frame), hbox);
      	gtk_widget_show (hbox);
      	
        statusbar = gtk_progress_bar_new ();
        gtk_box_pack_start (GTK_BOX (hbox), statusbar, FALSE, TRUE, 0);
      	gtk_progress_bar_update (GTK_PROGRESS_BAR (statusbar), 0.0);
      	gtk_widget_show (statusbar);
      	gtk_widget_show(progwindow);
      	
	while (fgets(tstring, 250, infile) != NULL)
	{
		error_msg[0] = 0;
		error_flag = 0;
		tstring3[0] = 0;
		open = 0.0;
		date = 0;
		high = 0.0;
		low = 0.0;
		close = 0.0;
		volume = 0;
		openint = 0;
		tint = strlen(tstring);
		if (seperator == 2)
		{
			for (tint2 = 0; tint2 < tint; tint2++)
			{
				if (tstring[tint2] == ',')
					tstring[tint2] = ' ';
			}
		}
		switch(format)
		{
			case 1 : sscanf(tstring,"%s %s %g %g %g %g %ld %ld", tstring3, tstring2, &open, &high, &low, &close, &volume, &openint);
				 break;
			case 2 : sscanf(tstring,"%s %s %g %g %g %ld", tstring3, tstring2, &high, &low, &close, &volume);
				 break;
			case 3 : sscanf(tstring,"%s %s %g", tstring3, tstring2, &close);
				 break;
			case 4 : sscanf(tstring,"%s %s %g %g %g %g", tstring3, tstring2, &open, &high, &low, &close);
				 break;
			case 5 : sscanf(tstring,"%s %s %g %g %g %g %ld", tstring3, tstring2, &open, &high, &low, &close, &volume);
				 break;
			default : break;
		}
		tstringpointer = strchr(tstring2, '/');
		if (tstringpointer != NULL)
		{
			tint3 = 0;
			tstring[0] = 0;
			tint = strlen(tstring2);
			for (tint2 = 0; tint2 <= tint; tint2++)
			{
				if (tstring2[tint2] != '/')
				{
					tstring[tint3] = tstring2[tint2];
					tint3++;
				}
			}
			tstring[tint3] = 0;
		}
		tint = strlen(tstring2);
		switch(dateformat)
		{
			case 1 : if (tint != 8)
				 {
				 	strcpy(error_msg, "Invalid date format");
				 	error_flag++;
				 }
				 else
				 	date = atol(tstring2);
				 break;
			case 2 : if (tint != 8)
				 {
				 	strcpy(error_msg, "Invalid date format");
				 	error_flag++;
				 }
				 else
				 {
				 	tstring[0] = tstring2[4];
				 	tstring[1] = tstring2[5];
				 	tstring[2] = tstring2[6];
				 	tstring[3] = tstring2[7];
				 	tstring[4] = tstring2[0];
				 	tstring[5] = tstring2[1];
				 	tstring[6] = tstring2[2];
				 	tstring[7] = tstring2[3];
				 	tstring[8] = 0;
				 	date = atol(tstring);
				}
				 break;
			case 3 : if (tint != 8)
				 {
				 	strcpy(error_msg, "Invalid date format");
				 	error_flag++;
				 }
				 else
				 {
				 	tstring[0] = tstring2[4];
				 	tstring[1] = tstring2[5];
				 	tstring[2] = tstring2[6];
				 	tstring[3] = tstring2[7];
				 	tstring[4] = tstring2[2];
				 	tstring[5] = tstring2[3];
				 	tstring[6] = tstring2[0];
				 	tstring[7] = tstring2[1];
				 	tstring[8] = 0;
				 	date = atol(tstring);
				}
				 break;
			default : break;
		}
		if (strlen(tstring3) == 0)
		{
			strcpy(error_msg, "Invalid symbol.");
			error_flag++;
		}
		if (chartflag)
		{
			if (! strcmp(tstring3, symbol))
				reload_flag++;
		}
		if (error_flag != 1)
		{
      			strcpy(tstring, datapath);
			strcat(tstring, tstring3);
			outfile = fopen(tstring, "r+b");
			if (outfile != 0)
			{
				fseek(outfile, 0L, SEEK_END);
				tlong = ftell(outfile);
				tlong = tlong - HEADERSIZE;
				records = tlong / RECORDSIZE;
				if (records == 1)
					fseek(outfile, HEADERSIZE, SEEK_SET);
				else
					fseek(outfile, ((long)(records - 1)*RECORDSIZE) + HEADERSIZE, SEEK_SET);
				fread(&tlong, sizeof(unsigned long), 1, outfile);
				if (date > tlong)
				{
					fclose(outfile);
					outfile = fopen(tstring, "ab");
					fwrite(&date, sizeof(unsigned long), 1, outfile);
					fwrite(&open, sizeof(float), 1, outfile);
					fwrite(&high, sizeof(float), 1, outfile);
					fwrite(&low, sizeof(float), 1, outfile);
					fwrite(&close, sizeof(float), 1, outfile);
					fwrite(&volume, sizeof(unsigned long), 1, outfile);
					fwrite(&openint, sizeof(unsigned long),1,outfile);
					fclose(outfile);
				}
				else
				{
					lowlist = 0;
					highlist = records;
					found_flag = 0;
					while (found_flag != 999)
					{
						middlelist = (lowlist + highlist) / 2;
						if (highlist < lowlist)
							break;
						fseek(outfile,((long)middlelist * RECORDSIZE) + HEADERSIZE, SEEK_SET);
						fread(&tlong, sizeof(long), 1, outfile);
						if (date > tlong)
							lowlist = middlelist + 1;
						else
						{
							if (date < tlong)
								highlist = middlelist - 1;
							else
							{
								found_flag = 1;
								break;
							}
						}
					}
					if (found_flag)
					{
						fseek(outfile, ((long)middlelist * RECORDSIZE) + HEADERSIZE, SEEK_SET);
						fwrite(&date, sizeof(unsigned long), 1, outfile);
						fwrite(&open, sizeof(float), 1, outfile);
						fwrite(&high, sizeof(float), 1, outfile);
						fwrite(&low, sizeof(float), 1, outfile);
						fwrite(&close, sizeof(float), 1, outfile);
						fwrite(&volume, sizeof(unsigned long), 1, outfile);
						fwrite(&openint, sizeof(unsigned long),1,outfile);
						fclose(outfile);
					}
					else
					{
						fseek(outfile, HEADERSIZE, SEEK_SET);
						strcpy(tstring, datapath);
						strcat(tstring, "temp.dat");
						outfile2 = fopen(tstring, "wb");
						if (! outfile2)
						{
							error_message = cant_create_tempfile;
							display_message();
							return;
						}
						strncpy(tname, tsymbol, NAME_SIZE);
						fwrite(&tname, NAME_SIZE, 1, outfile2);
						fwrite(&tsymbol, SYMBOL_SIZE, 1, outfile2);
						fwrite(&tint, sizeof(int), 1, outfile2);
						fwrite(&tint, sizeof(int), 1, outfile2);
						fwrite(&tfloat, sizeof(float), 1, outfile2);
						fwrite(&tfloat, sizeof(float), 1, outfile2);
						fwrite(&tfloat, sizeof(float), 1, outfile2);
						found_flag = 0;
						for (count = 1; count <= records; count++)
						{
							fread(&tlong,sizeof(unsigned long),1,outfile);
							fread(&tfloat, sizeof(float),1,outfile);
							fread(&tfloat2,sizeof(float),1,outfile);
							fread(&tfloat3,sizeof(float),1,outfile);
							fread(&tfloat4,sizeof(float),1,outfile);
							fread(&tlong2,sizeof(unsigned long),1,outfile);
							fread(&tlong3,sizeof(unsigned long),1,outfile);
							if (found_flag)
							{
								fwrite(&tlong, sizeof(unsigned long), 1, outfile2);
								fwrite(&tfloat, sizeof(float),1,outfile2);
								fwrite(&tfloat2,sizeof(float),1,outfile2);
								fwrite(&tfloat3,sizeof(float),1,outfile2);
								fwrite(&tfloat4,sizeof(float),1,outfile2);
								fwrite(&tlong2,sizeof(unsigned long), 1, outfile2);
								fwrite(&tlong3, sizeof(unsigned long),1,outfile2);
							}
							else
							{
								if (tlong > date)
								{
									fwrite(&date, sizeof(unsigned long), 1, outfile2);
									fwrite(&open, sizeof(float), 1, outfile2);
									fwrite(&high, sizeof(float), 1, outfile2);
									fwrite(&low, sizeof(float), 1, outfile2);
									fwrite(&close, sizeof(float), 1, outfile2);
									fwrite(&volume, sizeof(unsigned long), 1, outfile2);
									fwrite(&openint, sizeof(unsigned long),1,outfile2);
									fwrite(&tlong, sizeof(unsigned long), 1, outfile2);
									fwrite(&tfloat, sizeof(float), 1, outfile2);
									fwrite(&tfloat2, sizeof(float), 1, outfile2);
									fwrite(&tfloat3, sizeof(float), 1, outfile2);
									fwrite(&tfloat4, sizeof(float), 1, outfile2);
									fwrite(&tlong2, sizeof(unsigned long), 1, outfile2);
									fwrite(&tlong3, sizeof(unsigned long), 1, outfile2);
									found_flag = 1;
								}
								else
								{
									fwrite(&tlong, sizeof(unsigned long), 1, outfile2);
									fwrite(&tfloat, sizeof(float),1,outfile2);
									fwrite(&tfloat2,sizeof(float),1,outfile2);
									fwrite(&tfloat3,sizeof(float),1,outfile2);
									fwrite(&tfloat4,sizeof(float),1,outfile2);
									fwrite(&tlong2,sizeof(unsigned long), 1, outfile2);
									fwrite(&tlong3, sizeof(unsigned long),1,outfile2);
								}
							}
						}
						fclose(outfile);
						fclose(outfile2);
						strcpy(tstring, datapath);
						strcat(tstring, tstring3);
						unlink(tstring);
						strcpy(tstring, datapath);
						strcat(tstring, "temp.dat");
						strcpy(tstring2, datapath);
						strcat(tstring2, tstring3);
						rename(tstring, tstring2);
					}
				}
			}
			else
			{
				outfile = fopen(tstring, "wb");
				if (! outfile)
				{
					error_message = cant_create_chart;
					display_message();
					return;
				}
				strncpy(tname, tstring3, NAME_SIZE);
				strncpy(tsymbol, tstring3, SYMBOL_SIZE);
				fwrite(&tname, NAME_SIZE, 1, outfile);
				fwrite(&tsymbol, SYMBOL_SIZE, 1, outfile);
				tint = 0;
				tfloat = 0.0;
				fwrite(&tint, sizeof(int), 1, outfile);
				fwrite(&tint, sizeof(int), 1, outfile);
				fwrite(&tfloat, sizeof(float), 1, outfile);
				fwrite(&tfloat, sizeof(float), 1, outfile);
				fwrite(&tfloat, sizeof(float), 1, outfile);
				fwrite(&date, sizeof(unsigned long), 1, outfile);
				fwrite(&open, sizeof(float), 1, outfile);
				fwrite(&high, sizeof(float), 1, outfile);
				fwrite(&low, sizeof(float), 1, outfile);
				fwrite(&close, sizeof(float), 1, outfile);
				fwrite(&volume, sizeof(unsigned long), 1, outfile);
				fwrite(&openint, sizeof(unsigned long),1,outfile);
				fclose(outfile);
			}
		}
		else
		{
			strcpy(tstring, "Bad data, line# ");
			sprintf(tstring2, "%ld", importline);
			strcat(tstring, tstring2);
			strcat(tstring, " ");
			strcat(tstring, error_msg);
			strcat(tstring, ", data not imported");
			strcat(tstring, "\n");
			fputs(tstring, errorlog_file);
		}
		importline++;
		tfloat = ((float)importline / linecount);
		gtk_progress_bar_update (GTK_PROGRESS_BAR (statusbar), tfloat);
		while (gtk_events_pending())
			gtk_main_iteration();
	}
	fclose(infile);
	fclose(errorlog_file);
	gtk_widget_destroy(progwindow);
	if(error_msg[0] != 0)
	{
		error_message = error_notify;
		display_message();
	}
	if (reload_flag)
	{
		load_file();
		draw();
	}
}
/*****************************************************************************/
void open_import()
{
	gchar tstring[250];
	extern GtkWidget *openfile;
   	extern char *lastdir;
   	extern exit_openfile();
   	extern int openfile_flag;
   	
	
	if (openfile_flag)
		exit_openfile();
		
	openfile = gtk_file_selection_new("Select File To Import");
	gtk_signal_connect (GTK_OBJECT (openfile), "delete_event",
			    GTK_SIGNAL_FUNC (exit_openfile), NULL);
	gtk_signal_connect (GTK_OBJECT (openfile), "destroy",
			    GTK_SIGNAL_FUNC (exit_openfile), NULL);
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(openfile)->ok_button), "clicked",
			    GTK_SIGNAL_FUNC (get_import_filename), NULL);
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(openfile)->cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (exit_openfile), NULL);
	gtk_window_position(GTK_WINDOW (openfile), GTK_WIN_POS_CENTER);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION (openfile), tstring);
        if (lastdir)
        	gtk_file_selection_set_filename(GTK_FILE_SELECTION (openfile), lastdir);
        else
        	gtk_file_selection_set_filename(GTK_FILE_SELECTION (openfile), "~/");
        gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION(openfile));
        gtk_widget_show(openfile);
        openfile_flag = 1;
}
/*******************************************************************************************/
void import_options()
{
	GtkWidget *vbox, *vbox2, *vbox3, *vbox4, *hbox, *frame, *frame2, *hsep, *button, *button2;
	GtkWidget *frame3, *vbox5, *hbox2, *button3, *button4, *hbox3;
	extern GtkWidget *import_options_window, *import_options_radio, *import_options_radio2;
	extern GtkWidget *import_options_radio3, *import_options_radio4, *import_options_radio5;
	extern GtkWidget *import_options_radio6, *import_options_radio7;
	extern GtkWidget *import_options_radio8, *import_options_radio9, *import_options_radio10;
	extern GtkWidget *import_options_entry;
	extern exit_import_options_window(), display_message(), exit_openfile();
	extern help_import_options_window();
	extern int import_options_flag;
	
	
	if (import_options_flag)
		return;
	import_options_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (import_options_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_import_options_window), NULL);
	gtk_signal_connect (GTK_OBJECT (import_options_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_import_options_window), NULL);
	gtk_window_position(GTK_WINDOW (import_options_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (import_options_window), "Import Options");
	gtk_container_border_width (GTK_CONTAINER (import_options_window), 0);
	gtk_widget_set_usize(GTK_WIDGET (import_options_window), 0, 0);
	
	vbox = gtk_vbox_new (FALSE, 10);
     	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_container_add (GTK_CONTAINER (import_options_window), vbox);
      	gtk_widget_show (vbox);
      	
      	vbox2 = gtk_vbox_new (FALSE, 10);
     	gtk_container_border_width (GTK_CONTAINER (vbox2), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), vbox2, FALSE, TRUE, 0);
      	gtk_widget_show (vbox2);
      	
      	frame3 = gtk_frame_new("Import Filename:");
      	gtk_container_border_width (GTK_CONTAINER (frame3), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), frame3, FALSE, TRUE, 0);
      	gtk_widget_show(frame3);
      	
      	hbox3 = gtk_hbox_new (FALSE, 10);
      	gtk_container_add (GTK_CONTAINER (frame3), hbox3);
        gtk_container_border_width (GTK_CONTAINER (hbox3), 5);
        gtk_widget_show (hbox3);
      	
      	button4 = gtk_button_new_with_label("Import From...");
      	gtk_box_pack_start (GTK_BOX (hbox3), button4, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button4), "clicked",
			    GTK_SIGNAL_FUNC (open_import), NULL);
      	gtk_widget_show (button4);
      	
      	import_options_entry = gtk_entry_new ();
      	gtk_box_pack_start (GTK_BOX (hbox3), import_options_entry, TRUE, TRUE, 0);
      	gtk_entry_set_text(GTK_ENTRY(import_options_entry), "/tmp/import.txt");
      	gtk_widget_show (import_options_entry);
      	
      	frame = gtk_frame_new("Import Field Format:");
      	gtk_container_border_width (GTK_CONTAINER (frame), 0);
      	gtk_box_pack_start (GTK_BOX (vbox2), frame, FALSE, TRUE, 0);
      	gtk_widget_show(frame);
      	
      	vbox3 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame), vbox3);
        gtk_container_border_width (GTK_CONTAINER (vbox3), 5);
        gtk_widget_show (vbox3);
        
        import_options_radio = gtk_radio_button_new_with_label(NULL,"Symbol Date Open High Low Close Volume OpenInt");
      	gtk_box_pack_start (GTK_BOX (vbox3), import_options_radio, FALSE, TRUE, 0);
      	gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (import_options_radio), TRUE);
      	gtk_widget_show (import_options_radio);

      	import_options_radio2 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio)), "Symbol Date High Low Close Volume");
      	gtk_box_pack_start (GTK_BOX (vbox3), import_options_radio2, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio2);

      	import_options_radio3 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio)), "Symbol Date Close");
      	gtk_box_pack_start (GTK_BOX (vbox3), import_options_radio3, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio3);
      	
      	import_options_radio4 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio)), "Symbol Date Open High Low Close");
      	gtk_box_pack_start (GTK_BOX (vbox3), import_options_radio4, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio4);
      	
      	import_options_radio5 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio)), "Symbol Date Open High Low Close Volume");
      	gtk_box_pack_start (GTK_BOX (vbox3), import_options_radio5, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio5);
      	
      	hbox2 = gtk_hbox_new (FALSE, 10);
        gtk_container_border_width (GTK_CONTAINER (hbox2), 0);
        gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);
        gtk_widget_show (hbox2);
      	
      	frame2 = gtk_frame_new("Field Separator:");
      	gtk_container_border_width (GTK_CONTAINER (frame2), 0);
      	gtk_box_pack_start (GTK_BOX (hbox2), frame2, TRUE, TRUE, 0);
      	gtk_widget_show(frame2);
      	
      	vbox4 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame2), vbox4);
        gtk_container_border_width (GTK_CONTAINER (vbox4), 5);
        gtk_widget_show (vbox4);
        
        import_options_radio6 = gtk_radio_button_new_with_label (NULL, "Space");
      	gtk_box_pack_start (GTK_BOX (vbox4), import_options_radio6, FALSE, TRUE, 0);
      	gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (import_options_radio6), TRUE);
      	gtk_widget_show (import_options_radio6);

      	import_options_radio7 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio6)), "Comma");
      	gtk_box_pack_start (GTK_BOX (vbox4), import_options_radio7, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio7);
      	
      	frame3 = gtk_frame_new("Date Format:");
      	gtk_container_border_width (GTK_CONTAINER (frame3), 0);
      	gtk_box_pack_start (GTK_BOX (hbox2), frame3, TRUE, TRUE, 0);
      	gtk_widget_show(frame3);
      	
      	vbox5 = gtk_vbox_new (FALSE, 0);
        gtk_container_add (GTK_CONTAINER (frame3), vbox5);
        gtk_container_border_width (GTK_CONTAINER (vbox5), 5);
        gtk_widget_show (vbox5);
        
        import_options_radio8 = gtk_radio_button_new_with_label (NULL, "YYYYMMDD");
      	gtk_box_pack_start (GTK_BOX (vbox5), import_options_radio8, FALSE, TRUE, 0);
      	gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (import_options_radio8), TRUE);
      	gtk_widget_show (import_options_radio8);
      	
      	import_options_radio9 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio8)), "MMDDYYYY");
      	gtk_box_pack_start (GTK_BOX (vbox5), import_options_radio9, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio9);
      	
      	import_options_radio10 = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(import_options_radio8)), "DDMMYYYY");
      	gtk_box_pack_start (GTK_BOX (vbox5), import_options_radio10, FALSE, TRUE, 0);
      	gtk_widget_show (import_options_radio10);
      	
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
        gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_widget_show(hbox);
      		
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (ok_import), NULL);
      	gtk_widget_show (button);
      		
      	button2 = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_import_options_window), NULL);
      	gtk_widget_show (button2);
      	
      	button3 = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (hbox), button3, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button3), "clicked",
			    GTK_SIGNAL_FUNC (help_import_options_window), NULL);
      	gtk_widget_show (button3);
      	
      	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(button);	
      	import_options_flag = 1;
      	gtk_widget_show(import_options_window);
}